//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  ʐ^̂ڂ摜̍쐬
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2017N0801 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, GDIPAPI, GDIPOBJ, GDIPUTIL, Spin;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Image2: TImage;
    CheckBox1: TCheckBox;
    SpinEdit1: TSpinEdit;
    Image1: TImage;
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Privat  e 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  plBlurGDIplus;

{$R *.DFM}

//=============================================================================
//  tH[̏
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin
  SpinEdit1.Value := 5;
end;

//=============================================================================
//  `̈ڂ
//  ʐ^̂ڂ摜쐬p
//
//  TImageAutoSizevpeB̒lTrueɂĂ
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LGPGraphic    : TGPGraphics;
  LGPBitmap     : TGPBitmap;
  LGPBlurBitmap : TGPBitmap;
  LStream       : TMemoryStream;
  LImgWidth     : Integer;
  LImgHeight    : Integer;
  LImgFilePath  : string;
  LRadius       : Integer;
begin
  LRadius := SpinEdit1.Value;

  LImgFilePath := ExpandFileName('PenguinsB.bmp');
  LStream := TMemoryStream.Create;
  try
    //摜Xg[ɓǂݍŏ
    LStream.LoadFromFile(LImgFilePath);

    //Xg[TGPBitmap𐶐
    LGPBitmap  := TGPBitmap.Create(TStreamAdapter.Create(LStream, soReference));
    LImgWidth  := LGPBitmap.GetWidth;
    LImgHeight := LGPBitmap.GetHeight;

    //ڂ摜쐬
    if CheckBox1.Checked then begin
      LGPBlurBitmap := BoxBlur(LGPBitmap, LRadius);
    end else begin
      LGPBlurBitmap := GaussianBlur(LGPBitmap, LRadius, 1);
    end;

    //̉摜TImageɕ`
    Image1.Picture.Assign(nil);
    Image1.Left := 10;

    Image1.Picture.Bitmap.SetSize(LImgWidth + 20, LImgHeight + 20);
    LGPGraphic := TGPGraphics.Create(Image1.Canvas.Handle);
    LGPGraphic.DrawImage(LGPBitmap, 15, 15);


    FreeAndNil(LGPGraphic);

    //쐬ڂ摜TImageɕ`
    Image2.Picture.Assign(nil);
    Image2.Left := Image1.Left + Image1.Width + 10;
    Image2.Top  := Image1.Top;
    Image2.Picture.Bitmap.SetSize(LImgWidth + 20, LImgHeight + 20);
    LGPGraphic := TGPGraphics.Create(Image2.Canvas.Handle);
    LGPGraphic.DrawImage(LGPBlurBitmap, 15, 15);
  finally
    FreeAndNil(LGPGraphic);
    FreeAndNil(LGPBitmap);
    FreeAndNil(LGPBlurBitmap);
    FreeAndNil(LStream);
  end;
end;

//=============================================================================
//  CheckBox1OnClickCxg
//  Gaussian BlurBox Blur̐؂芷
//=============================================================================
procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  Button1Click(nil);
end;

//=============================================================================
//  SpinEdit1OnChangeCxg
//  ڂvZ͈̔͂ύX
//=============================================================================
procedure TForm1.SpinEdit1Change(Sender: TObject);
begin
  if SpinEdit1.Value < 0 then begin
    SpinEdit1.Value := 0;
  end else begin
    Button1Click(nil);
  end;
end;

end.
