//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  摜Drop Shadow(̉e)`
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2017N0801 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, GDIPAPI, GDIPOBJ, GDIPUTIL;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    Image2: TImage;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Privat  e 錾 }
    function SetAlphaValueFromTBitmap(DstGPBitmap: TGPBitmap;
      SrcBitmap: TBitmap): Boolean;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  plBlurGDIplus;

{$R *.DFM}

//=============================================================================
//  摜Drop Shadow(̉e)`
//
//  TImageAutoSize̒lTrueɂĂ
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LGPGraphic    : TGPGraphics;
  LGPBitmap     : TGPBitmap;
  LGPBlurBitmap : TGPBitmap;
  LGPDstBitmap  : TGPBitmap;
  LBitmap       : TBitmap;
  LStream       : TMemoryStream;
  LImgWidth     : Integer;
  LImgHeight    : Integer;
  LImgFilePath  : string;
  LRadius       : Integer;
begin
  LRadius := 3;

  //Ώۂ̃rbg}bv摜t@C
  LImgFilePath := ExpandFileName('503_Transe.bmp');

  LBitmap := TBitmap.Create;
  LStream := TMemoryStream.Create;
  try
    //rbg}bv摜Xg[ɓǂݍŏ
    LStream.LoadFromFile(LImgFilePath);
    LStream.Position :=0;
    LBitmap.LoadFromStream(LStream);

    //Xg[TGPBitmap𐶐
    LGPBitmap := TGPBitmap.Create(TStreamAdapter.Create(LStream, soReference));
    if LBitmap.PixelFormat = pf32bit then begin
      //TGPBitmapTBitmap̃At@`l悤ɂ
      SetAlphaValueFromTBitmap(LGPBitmap, LBitmap);
    end;
    LImgWidth  := LGPBitmap.GetWidth;
    LImgHeight := LGPBitmap.GetHeight;


    //ڂ摜쐬(ۂɂ͂ڂ摜̃}XN摜)
    if CheckBox1.Checked then begin
      LGPBlurBitmap := CreateBoxBlurShadow(LGPBitmap, LRadius, 0.5, clBlack);
    end else begin
      LGPBlurBitmap := CreateGaussianBlurShadow(LGPBitmap, LRadius, 0.5, clBlack);
    end;
    

    //ʗpTGPBitmap𐶐āCɂڂ摜ƌ̉d˕`
    LGPDstBitmap := TGPBitmap.Create(LImgWidth + 20, LImgHeight + 20);
    LGPGraphic := TGPGraphics.Create(LGPDstBitmap);
    LGPGraphic.DrawImage(LGPBlurBitmap, -LRadius * 2 + 5, -LRadius * 2 + 5);
    LGPGraphic.DrawImage(LGPBitmap, 0, 0);


    FreeAndNil(LGPGraphic);

    //Image1Ɍ̉摜`
    Image1.Picture.Assign(nil);
    Image1.Picture.Bitmap.SetSize(LImgWidth + 20, LImgHeight + 20);
    LGPGraphic := TGPGraphics.Create(Image1.Canvas.Handle);
    LGPGraphic.DrawImage(LGPBitmap, 0, 0);

    FreeAndNil(LGPGraphic);

    //Image2ɏd˕`悵ʂ̉摜`
    Image2.Picture.Assign(nil);
    Image2.Left := Image1.Left + Image1.Width + 10;
    Image2.Picture.Bitmap.SetSize(LImgWidth + 20, LImgHeight + 20);
    LGPGraphic := TGPGraphics.Create(Image2.Canvas.Handle);
    LGPGraphic.DrawImage(LGPDstBitmap, 0, 0);
  finally
    FreeAndNil(LGPGraphic);
    FreeAndNil(LBitmap);
    FreeAndNil(LGPBitmap);
    FreeAndNil(LGPBlurBitmap);
    FreeAndNil(LGPDstBitmap);
    FreeAndNil(LStream);
  end;
end;

//=============================================================================
//  CheckBox1OnClickCxg
//  Gaussian BlurBox Blur̐؂芷
//=============================================================================
procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  Button1Click(nil);
end;

//-----------------------------------------------------------------------------
//  ǂݍ񂾃rbg}bv(TBitmap)摜̃At@l̏
//
//  TGPBitmapTBitmap̃At@`lȂ
//  TBitmap̃At@lTGPBitmap̃At@lɑ
//  At@`ltTBitmapAt@`ltŕ\\ɂ
//  ̃rbg[32bitȏp
//-----------------------------------------------------------------------------
function TForm1.SetAlphaValueFromTBitmap(DstGPBitmap: TGPBitmap;
  SrcBitmap: TBitmap): Boolean;
type
  TRGBQArray = array [0..4095] of RGBQUAD;
  PRGBQArray = ^TRGBQArray;
var
  LImgWidth   : Integer;
  LImgHeight  : Integer;
  LBmpData    : TBitmapData;
  LScanLine   : PByte;
  LpRGBQuad   : PRGBQuad;
  LDataStride : Integer;
  LXPos       : integer;
  LYPos       : Integer;
  LScanArray  : PRGBQArray;
  LAValue     : Byte;
  LRValue     : Byte;
  LGValue     : Byte;
  LBValue     : Byte;
begin
  Result := False;

  LImgWidth  := DstGPBitmap.GetWidth;
  LImgHeight := DstGPBitmap.GetHeight;

  //TGPBitmap̃rbg}bvf[^擾
  if DstGPBitmap.LockBits(MakeRect(0, 0, LImgWidth, LImgHeight), ImageLockModeWrite,
                                 PixelFormat32bppARGB, LBmpData) <> Ok then exit;

  SrcBitmap.Canvas.Lock;

  LScanLine   := LBmpData.Scan0;
  LDataStride := LBmpData.Stride;

  for LYPos := 0 to LImgHeight - 1 do begin
    LpRGBQuad  := PRGBQuad(LScanLine);
    LScanArray := SrcBitmap.ScanLine[LYPos];

    for LXPos := 0 to LImgWidth - 1 do begin

      LAValue := LScanArray[LXPos].rgbReserved;
      LRValue := LScanArray[LXPos].rgbRed;
      LGValue := LScanArray[LXPos].rgbGreen;
      LBValue := LScanArray[LXPos].rgbBlue;

      if MakeColor(LRValue, LGValue, LBValue, LAValue) = 0 then begin
        LpRGBQuad^.rgbReserved := 0;
      end else
      if (LAValue = 0) then begin
        LpRGBQuad^.rgbReserved := $FF;
      end else begin
        LpRGBQuad^.rgbReserved := LScanArray[LXPos].rgbReserved;
      end;
      Inc(LpRGBQuad);
    end;
    Inc(LScanLine, LDataStride);
  end;

  SrcBitmap.Canvas.Unlock;
  DstGPBitmap.UnlockBits(LBmpData);
  Result := True;
end;

end.
