//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  ACR摜Drop Shadow(̉e)`
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2017N0801 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, GDIPAPI, GDIPOBJ, GDIPUTIL;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Image2: TImage;
    Image1: TImage;
    Image3: TImage;
    Image4: TImage;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Privat  e 錾 }
    procedure DisplayImageAndGridLine(AImageCtrl, ARealSizeImage: TImage;
      TargetGPBitmap: TGPBitmap);
  public
    { Public 錾 }
    procedure DrawPixelColorToTImage(SrcGPBitmap: TGPBitmap; DrawTimage: TImage;
      PixelRectSize: Integer; MaxImgPixels: Integer; GridLineColor: TColor;
      BackImage: TBitmap = nil; ShowGridLine: Boolean = True;
      BackGround: Boolean = True);
  end;

var
  Form1: TForm1;

implementation

uses
  plBlurGDIplus;

{$R *.DFM}

//=============================================================================
//  ACR摜Drop Shadow(̉e)`
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LGPGraphic    : TGPGraphics;
  LGPBitmap     : TGPBitmap;
  LGPBlurBitmap : TGPBitmap;
  LGPDstBitmap  : TGPBitmap;
  LStream       : TMemoryStream;
  LImgWidth     : Integer;
  LImgHeight    : Integer;
  LImgFilePath  : string;
  LSaveFilePath : string;
  LImgGUID      : TGUID;
begin
  //Ώۂ̃rbg}bv摜t@C
  LImgFilePath := ExpandFileName('livejournal-old.png');

  LStream := TMemoryStream.Create;
  try
    //摜Xg[ɓǂݍŏ
    LStream.LoadFromFile(LImgFilePath);

    //Xg[TGPBitmap𐶐
    LGPBitmap := TGPBitmap.Create(TStreamAdapter.Create(LStream, soReference));
    LImgWidth  := LGPBitmap.GetWidth;
    LImgHeight := LGPBitmap.GetHeight;

    
    //ڂ摜쐬(ۂɂ̓}XN摜̂ڂ摜)
    if CheckBox1.Checked then begin
      LGPBlurBitmap := CreateBoxBlurShadow(LGPBitmap, 1, 0.45, clBlack);
    end else begin
      LGPBlurBitmap := CreateGaussianBlurShadow(LGPBitmap, 1, 0.45, clBlack);
    end;
    

    //ʗpTGPBitmap𐶐āCɂڂ摜ƌ̉d˕`
    LGPDstBitmap := TGPBitmap.Create(LImgWidth, LImgHeight);
    LGPGraphic := TGPGraphics.Create(LGPDstBitmap);
    LGPGraphic.DrawImage(LGPBlurBitmap, -1.5, -1.5);
    LGPGraphic.DrawImage(LGPBitmap, 0, 0);


    //Image1Ɍ̉摜`
    DisplayImageAndGridLine(Image1, Image2, LGPBitmap);

    //Image2ɏd˕`悵ʂ̉摜`
    Image3.Left := Image1.Left + Image1.Width + 10;
    Image4.Left := Image1.Left + Image1.Width + 10;
    DisplayImageAndGridLine(Image3, Image4, LGPDstBitmap);

    //PNG摜Ƃĕۑ
    if GetEncoderClsid('image/png', LImgGUID) >= 0 then begin
      LSaveFilePath := ExtractFilePath(LImgFilePath)
                     + ChangeFileExt(ExtractFileName(LImgFilePath), '') + '-Blur.png';
      LGPDstBitmap.Save(LSaveFilePath, LImgGUID);
    end;
  finally
    FreeAndNil(LGPGraphic);
    FreeAndNil(LGPBitmap);
    FreeAndNil(LGPBlurBitmap);
    FreeAndNil(LGPDstBitmap);
    FreeAndNil(LStream);
  end;
end;

//=============================================================================
//  CheckBox1OnClickCxg
//  Gaussian BlurBox Blur̐؂芷
//=============================================================================
procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  Button1Click(nil);
end;

//-----------------------------------------------------------------------------
//  TCYƊg債ăObh\̉摜`
//-----------------------------------------------------------------------------
procedure TForm1.DisplayImageAndGridLine(AImageCtrl, ARealSizeImage: TImage;
  TargetGPBitmap: TGPBitmap);
var
  LGPGraphics : TGPGraphics;
begin
  //TGPBitmapTImageɕ`
  if ARealSizeImage <> nil then begin
    ARealSizeImage.Picture.Assign(nil);
    LGPGraphics := TGPGraphics.Create(ARealSizeImage.Canvas.Handle);
    LGPGraphics.DrawImage(TargetGPBitmap, 0, 0);
    LGPGraphics.Free;
  end;
  if AImageCtrl = nil then exit;

  //sNZ̃Obh\
  DrawPixelColorToTImage(TargetGPBitmap, AImageCtrl, 6, 32, clGray, nil, False);
end;

//-----------------------------------------------------------------------------
//  TGPBitmap̊esNZ̐FObh\
//-----------------------------------------------------------------------------
procedure TForm1.DrawPixelColorToTImage(SrcGPBitmap: TGPBitmap;
  DrawTimage: TImage; PixelRectSize: Integer;  MaxImgPixels: Integer;
  GridLineColor: TColor; BackImage: TBitmap = nil; ShowGridLine: Boolean = True;
  BackGround: Boolean = True);
type
  TRGBQArray = array [0..4095] of RGBQUAD;
  PRGBQArray = ^TRGBQArray;
var
  LSrcImgWidth  : Integer;
  LSrcImgHeight : Integer;
  LImgWidth     : Integer;
  LImgHeight    : Integer;
  LBmpData      : TBitmapData;
  LScanLine     : PByte;
  LpRGBQuad     : PRGBQuad;
  LDataStride   : Integer;
  LAValue       : Byte;
  LRValue       : Byte;
  LGValue       : Byte;
  LBValue       : Byte;
  LXPos         : Integer;
  LYPos         : Integer;
  LImgBitmap    : TBitmap;
  LDstScanArray : PRGBQArray;
  LiiX          : Integer;
  LiiY          : Integer;
  LGridRValue   : Byte;
  LGridGValue   : Byte;
  LGridBValue   : Byte;
begin
  DrawTimage.Picture.Assign(nil);

  //摜̃TCY擾
  LSrcImgWidth  := SrcGPBitmap.GetWidth;
  LSrcImgHeight := SrcGPBitmap.GetHeight;
  if LSrcImgWidth > MaxImgPixels  then LSrcImgWidth  := MaxImgPixels;
  if LSrcImgHeight > MaxImgPixels then LSrcImgHeight := MaxImgPixels;

  //Obh\̕`TCY
  LImgWidth  := LSrcImgWidth * PixelRectSize + 1;
  LImgHeight := LSrcImgHeight * PixelRectSize + 1;

  //wi摜̎w肪Ε`
  if (Assigned(BackImage)) and BackGround then begin
    DrawTimage.Canvas.Brush.Bitmap := BackImage;
    DrawTimage.Canvas.FillRect(DrawTimage.ClientRect);
  end;


  //TGPBitmap̃rbg}bvf[^擾
  if SrcGPBitmap.LockBits(MakeRect(0, 0, LSrcImgWidth, LSrcImgHeight),
             ImageLockModeRead, PixelFormat32bppARGB, LBmpData) <> Ok then exit;

  //sNZƃObh`悷TBitmap쐬
  //ɕ`悵TImageCanvasɕ`悷
  LImgBitmap := TBitmap.Create;
  try
    LImgBitmap.SetSize(LImgWidth, LImgHeight);
    LImgBitmap.PixelFormat := pf32bit;
    //AlphaFormat := afIgnoredƂĂ
    //afIgnoredɂȂĔ̃sNZɕ`łȂ
    //TImage.Canvasɕ`悷鎞afDefinedɂ
    LImgBitmap.AlphaFormat := afIgnored;

    LScanLine   := LBmpData.Scan0;
    LDataStride := LBmpData.Stride;

    //Obh̐FRGBl擾Ă
    LGridRValue := GetRValue(GridLineColor);
    LGridGValue := GetGValue(GridLineColor);
    LGridBValue := GetBValue(GridLineColor);

    for LYPos := 0 to LSrcImgHeight - 1 do begin
      LpRGBQuad := PRGBQuad(LScanLine);
      LImgBitmap.Canvas.Lock;

      for LXPos := 0 to LSrcImgWidth - 1 do begin

        LAValue := LpRGBQuad^.rgbReserved;
        LRValue := LpRGBQuad^.rgbRed;
        LGValue := LpRGBQuad^.rgbGreen;
        LBValue := LpRGBQuad^.rgbBlue;

        for LiiY := 0 to PixelRectSize do begin
          LDstScanArray  := LImgBitmap.ScanLine[LYPos * PixelRectSize + LiiY];

          //̕Obhւ̕`
          for LiiX := 0 to PixelRectSize do begin
            //Obh`悷Wl̎
            if (ShowGridLine) and ((LiiY = 0) or (LiiX = 0) or
              (LiiY = PixelRectSize) or (LiiX = PixelRectSize)) then begin
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbReserved := $FF;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbRed      := LGridRValue;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbGreen    := LGridGValue;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbBlue     := LGridBValue;
            end else begin
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbReserved := LAValue;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbRed      := LRValue;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbGreen    := LGValue;
              LDstScanArray[LXPos * PixelRectSize + LiiX].rgbBlue     := LBValue;
            end;
          end;
        end;

        Inc(LpRGBQuad);
      end;
      Inc(LScanLine, LDataStride);
    end;

    //쐬TBitmapTImageCanvasɕ`
    //AlphaFormat := afDefinedɂĔ摜̃sNZŕ\
    DrawTimage.Picture.Bitmap.SetSize(LImgWidth, LImgHeight);
    LImgBitmap.AlphaFormat := afDefined;
    DrawTimage.Canvas.Draw(0, 0, LImgBitmap);
  finally
    SrcGPBitmap.UnlockBits(LBmpData);
    LImgBitmap.Canvas.Unlock;

    FreeAndNil(LImgBitmap);
  end;
end;

end.
