//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  GDI+ ֌WTv
//  et̕`
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2017N0801 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, GDIPAPI, GDIPOBJ, GDIPUTIL;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private 錾 }
    procedure DrawGPBitmapToTImage(ATImage: TImage; AGPBitmap: TGPBitmap);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  plBlurGDIplus;

{$R *.DFM}

//=============================================================================
//  et̕`
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  LGPGraphic    : TGPGraphics;
  LGPBitmap     : TGPBitmap;
  LGPBlurBitmap : TGPBitmap;
  LGPDstBitmap  : TGPBitmap;
  LGPFont       : TGPFont;
  LGPBrush      : TGPSolidBrush;
  LFontSize     : Single;
  LGPColor      : TGPColor;
  LRadius       : Integer;
begin
  LFontSize := 60.0;
  LGPColor  := MakeColor($FF, 0, 0, 0);
  LRadius   := 2;

  //`悷TGpBitmap𐶐
  LGPBitmap  := TGPBitmap.Create(Image1.Width, Image1.Height);
  LGPGraphic := TGPGraphics.Create(LGPBitmap);
  try
    //tHgƕ`悷uVݒ
    LGPFont  := TGPFont.Create('Tahoma', LFontSize, FontStyleBold, UnitPixel);
    LGPBrush := TGPSolidBrush.Create(LGPColor);
    //̐ݒTGPBitmapɕ`
    LGPGraphic.DrawString('Delphi', -1, LGPFont, MakePoint(0.0, 0.0), LGPBrush);


    //ڂ摜쐬(ۂɂ͂ڂ摜̃}XN摜)
    if CheckBox1.Checked then begin
      LGPBlurBitmap := CreateBoxBlurShadow(LGPBitmap, LRadius, 0.5, clBlack);
    end else begin
      LGPBlurBitmap := CreateGaussianBlurShadow(LGPBitmap, LRadius, 0.5, clBlack);
    end;


    //Image1Ɍ̉摜CImage2ɂڂ摜`
    DrawGPBitmapToTImage(Image1, LGPBitmap);
    DrawGPBitmapToTImage(Image2, LGPBlurBitmap);

    FreeAndNil(LGPGraphic);

    //ʗpTGPBitmap𐶐āCɂڂ摜ƌ̉d˕`
    LGPDstBitmap := TGPBitmap.Create(Image1.Width, Image1.Height);
    LGPGraphic := TGPGraphics.Create(LGPDstBitmap);
    LGPGraphic.DrawImage(LGPBlurBitmap, -LRadius * 2 + 5, -LRadius * 2 + 5);
    LGPGraphic.DrawImage(LGPBitmap, 0, 0);

    //Image3ɏd˕`悵ʂ̉摜`
    DrawGPBitmapToTImage(Image3, LGPDstBitmap);
  finally
    FreeAndNil(LGPGraphic);
    FreeAndNil(LGPBitmap);
    FreeAndNil(LGPBlurBitmap);
    FreeAndNil(LGPDstBitmap);
    FreeAndNil(LGPFont);
    FreeAndNil(LGPBrush);
  end;
end;

//=============================================================================
//  CheckBox1OnClickCxg
//  Gaussian BlurBox Blur̐؂芷
//=============================================================================
procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  Button1Click(nil);
end;

//-----------------------------------------------------------------------------
//  Ŏw肷TImageRg[TGPBitmap`
//-----------------------------------------------------------------------------
procedure TForm1.DrawGPBitmapToTImage(ATImage: TImage; AGPBitmap: TGPBitmap);
var
  LGPGraphic : TGPGraphics;
begin
  ATImage.Picture.Assign(nil);

  LGPGraphic := TGPGraphics.Create(ATImage.Canvas.Handle);
  LGPGraphic.DrawImage(AGPBitmap, 0, 0);
end;

end.
